"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.host = exports.port = exports.base = exports.sessionSecret = exports.defaultPsw = exports.defaultUser = exports.configDbDir = exports.storeBackupsDir = exports.nvmBackupsDir = exports.backupsDir = exports.tmpDir = exports.snippetsDir = exports.logsDir = exports.storeDir = exports.title = void 0;
const utils_1 = require("../lib/utils");
const dotenv_1 = require("dotenv");
(0, dotenv_1.config)({ path: './.env.app' });
// config/app.js
exports.title = 'Z-Wave JS UI';
exports.storeDir = process.env.STORE_DIR || (0, utils_1.joinPath)(true, 'store');
exports.logsDir = process.env.ZWAVEJS_LOGS_DIR || (0, utils_1.joinPath)(exports.storeDir, 'logs');
exports.snippetsDir = (0, utils_1.joinPath)(exports.storeDir, 'snippets');
exports.tmpDir = (0, utils_1.joinPath)(exports.storeDir, '.tmp');
exports.backupsDir = process.env.BACKUPS_DIR || (0, utils_1.joinPath)(exports.storeDir, 'backups');
exports.nvmBackupsDir = (0, utils_1.joinPath)(exports.backupsDir, 'nvm');
exports.storeBackupsDir = (0, utils_1.joinPath)(exports.backupsDir, 'store');
exports.configDbDir = (0, utils_1.joinPath)(exports.storeDir, '.config-db');
exports.defaultUser = process.env.DEFAULT_USERNAME || 'admin';
exports.defaultPsw = process.env.DEFAULT_PASSWORD || 'zwave';
// lgtm [js/hardcoded-credentials]
exports.sessionSecret = process.env.SESSION_SECRET || 'DEFAULT_SESSION_SECRET_CHANGE_ME';
exports.base = process.env.BASE_PATH || '/';
exports.port = process.env.PORT || 8091;
exports.host = process.env.HOST; // by default undefined, so it will listen on all interfaces both ipv4 and ipv6
